#include "SDL/SDL.h"
#include "SDL/SDL_image.h"
//#include "SDL/SDL_ttf.h"

#include <string>

//#include "Files.h"
#include "shared.h"
#include "Button.h"

Button::Button(int x, int y, int w, int h, std::string filename, std::string filename2, bool toggle)
{
box.x=x;
box.y=y;
box.w=w;
box.h=h;

pushed = false;
toggle_status = toggle;

name[0]=filename;
name[1]=filename2;
}

void Button::load()
{
	surface[0] = load_image( name[0].c_str() );
	surface[1] = load_image( name[1].c_str() );
}

Button::~Button()
{
	SDL_FreeSurface( surface[0] );
	SDL_FreeSurface( surface[1] );
}

void Button::apply_button()
{
	if(toggle_status)
	{
		if(toggle)
		{
		apply_surface( box.x, box.y, surface[1], screen);
		}

		else
		{
		apply_surface( box.x, box.y, surface[0], screen);
		}
	}

	else
	{
		if(pushed)
		{
		apply_surface( box.x, box.y, surface[1], screen);
		}

		else
		{
		apply_surface( box.x, box.y, surface[0], screen);
		}
	}
}


bool Button::check()
{
int posx, posy;

	SDL_GetMouseState(&posx , &posy );

	if(SDL_GetMouseState(NULL , NULL ) & SDL_BUTTON(1) && event.type == SDL_MOUSEBUTTONDOWN)
	{
		if( posx > box.x
		&&  posx < box.x + box.w
		&&  posy > box.y
		&&  posy < box.y + box.h )
        {
        pushed=true;
		}
	}

	if( event.type == SDL_MOUSEBUTTONUP && pushed==true)
	{
		pushed=false;
		SDL_GetMouseState(&posx, &posy);

        if( posx > box.x
		&&  posx < box.x + box.w
		&&  posy > box.y
		&&  posy < box.y + box.h )
        {
        toggle ^= 1;
		return(true);
        }
	}
return (false);
}
