#include "Map_Pick.h"
#include "shared.h"
#include "fstream"
#include <sstream>
#include "windows.h"
//#include <stdio.h>

Map_Pick::Map_Pick()
{
    floor_count = 1;
    map_count = 1;
    updated = false;

    RegisterHotKey(
        NULL,
        1,
        0,
        112);  //0x42 is 'F1'
    RegisterHotKey(
        NULL,
        2,
        0,
        113);  //0x42 is 'F2'
    RegisterHotKey(
        NULL,
        3,
        0,
        115);  //0x42 is 'F4'
    RegisterHotKey(
        NULL,
        4,
        0,
        116);  //0x42 is 'F5'*/
    RegisterHotKey(
        NULL,
        5,
        0,
        121);  //0x42 is 'F10'*/
}

Map_Pick::~Map_Pick()
{
    //dtor
}

SDL_Surface* Map_Pick::Get_Image()
{
    //build folder
    if(updated == false)
    {
        SDL_FreeSurface(current_image);

        std::stringstream temp;
        temp << "../" << map_count << "/" << floor_count << "F.PNG";
        std::string path = temp.str();

        current_image = load_image(path);
    }
    return current_image;
}

std::string Map_Pick::Get_String()
{
    std::stringstream temp;
    temp << "Map used: " << map_count << " Floor: " << floor_count;
    std::string floor_info = temp.str();

    return floor_info;
}

std::vector<std::string> Map_Pick::Get_items()
{
    std::stringstream temp;
    temp << "../" << map_count << "/items.txt";
    std::string path = temp.str();

    std::vector<std::string> ret;

    std::string line;
    std::ifstream items;
    items.open(path);
    if (items.is_open())
    {
        while( getline (items,line) )
        {
            ret.push_back(line);
        }
        items.close();
    }
    return ret;
}

void Map_Pick::Read_Key(SDL_Event e)
{
    if( e.type == SDL_KEYDOWN )
    {
        switch( e.key.keysym.sym )
        {
            case SDLK_UP:
                floor_count++;
                updated = false;
            break;

            case SDLK_DOWN:
                floor_count--;
                updated = false;
            break;

            case SDLK_LEFT:
                map_count--;
                floor_count = 2;
                updated = false;
            break;

            case SDLK_RIGHT:
                map_count++;
                floor_count = 2;
                updated = false;
            break;

            default:
            break;
        }
    }
}

bool Map_Pick::Read_Key_Global()
{
    bool ret = false;
    MSG msg = {0};
    GetMessage(&msg, NULL, 0, 0);
    {
        if (msg.message == WM_HOTKEY)
        {
            if(msg.wParam == 1)
            {
                floor_count--;
            }
            if(msg.wParam == 2)
            {
                floor_count++;
            }
            if(msg.wParam == 3)
            {
                map_count--;
                floor_count = 1;
            }
            if(msg.wParam == 4)
            {
                map_count++;
                floor_count = 1;
            }
            if(msg.wParam == 5)
            {
                ret = true;
            }
        }
    }
    return ret;
}


